''''''''''''''''''''''''''''''''''''''
' Program    : Save Screen 13 as BMP '
' Programmer : Yousuf Philips        '
' Company    : Y P I                 '
' Updated On : 8th of July 1998      '
' Email - [philipz85@hotmail.com]    '
' [http://members.xoom.com/Philipz/] '
''''''''''''''''''''''''''''''''''''''

'/* The SAVEBMP function is able to save any portion of screen 13 as a BMP.*/'
'/* This program can be freely distributed as long as no changes are made  */'
'/* to the source code. If you use the SAVEBMP function in your source     */'
'/* code then remember to give YPI the credit it deserves.                 */'
'/* The SAVEBMP function is able to save the whole of screen 13 in 0.93    */'
'/* seconds on a 486, so you can imagine how fast it will go on a Pentium. */'
'/* If you were impressed by SAVEBMP then please e-mail us, we like to     */'
'/* recieve e-mails from BASIC programmers. And try to visit our website,  */'
'/* we have created many new BASIC utilities. Some of them are SPLIT,      */'
'/* MEMCHECK, OPENBMP, OPENPCX, SAVEBMP, SAVEPCX and OPENFLI. The names    */'
'/* should have given you the idea of what they do but if not check it out */'
'/* at our site.                                                           */'

DECLARE SUB SaveBMP (FileName$, MinX, MinY, MaxX, MaxY)
'/* FileName$ - The filename of the file that the saved screen is to be put*/'
'/* MinX - The starting x position                                         */'
'/* MinY - The starting y position                                         */'
'/* MaxX - The ending x position                                           */'
'/* MaxY - The ending y position                                           */'

SCREEN 13
FOR Circles = 1 TO 100
   CIRCLE (RND * 320, RND * 200), RND * 100, RND * 256
NEXT Circles
PRINT " Created By YPI"

t = TIMER
CALL SaveBMP("di.bmp", 0, 0, 319, 199)
PRINT " Time Taken To Save Screen -"; TIMER - t

SUB SaveBMP (FileName$, MinX, MinY, MaxX, MaxY)

'/* Calculationg the Width and Length in Pixels */'
WidthInPixels = (MaxX - MinX) + 1: LengthInPixels = (MaxY - MinY) + 1: a& = 1

OPEN FileName$ FOR BINARY AS #1
IF LOF(1) <> 0 THEN
   '/* The file isn't empty so we empty the file */'
   CLOSE #1
   KILL FileName$
   OPEN FileName$ FOR BINARY AS #1
END IF

'/* General Info Variables */'
ValidBMP$ = "BM": Empty$ = MKL$(0): PictureDataOffset$ = MKL$(1078)

PUT #1, , ValidBMP$             '/* Valid BMP's have 'BM' as the first two char's'
PUT #1, , Empty$                '/* Reserved until file size is calculated'
PUT #1, , Empty$                '/* Used to make the bytes in the file empty'
PUT #1, , PictureDataOffset$    '/* Offset of the Picture Data'

'/* Header Variables */'
WinOrOS2$ = MKL$(40): WidthInPixels$ = MKL$(WidthInPixels)
LengthInPixels$ = MKL$(LengthInPixels): NoOfPlanes$ = MKI$(1)
NoOfBits$ = MKI$(8): NoCompression$ = MKL$(0): AllColors$ = MKL$(0)

IF (4 - (WidthInPixels MOD 4)) = 4 THEN
   SizeOfImageInBytes$ = MKL$((WidthInPixels * LengthInPixels))
ELSE
   SizeOfImageInBytes$ = MKL$(((WidthInPixels + (4 - (WidthInPixels MOD 4))) * LengthInPixels))
END IF

PUT #1, , WinOrOS2$               '/* Defining if this is a Windows or OS/2 BMP'
PUT #1, , WidthInPixels$          '/* The Width of the Image in Pixels'
PUT #1, , LengthInPixels$         '/* The Length of the Image in Pixels'
PUT #1, , NoOfPlanes$             '/* Number of Planes. Shoule be 1'
PUT #1, , NoOfBits$               '/* Number of Bits. Should be 8'
PUT #1, , NoCompression$          '/* There is No Compression'
PUT #1, , SizeOfImageInBytes$     '/* Size of the picture data in bytes'
PUT #1, , Empty$                  '/* Using this variable to keep the place blank in file'
PUT #1, , Empty$                  '/* Using this variable to keep the place blank in file'
PUT #1, , AllColors$              '/* Number of Colors Used
PUT #1, , AllColors$              '/* Important Colors
       
'/* Palette Info */'
Empty$ = SPACE$(1)

FOR Colors = 0 TO 255
   '/* Extracts the Palette of each of the 256 colors into a red, green and */'
   '/* blue sections and places them into their corresponding variables     */'
   OUT &H3C6, &HFF
   OUT &H3C7, Colors
   Red$ = CHR$(INP(&H3C9) * 4): Green$ = CHR$(INP(&H3C9) * 4): Blue$ = CHR$(INP(&H3C9) * 4)
   '/* Places the extracted colors into the given file */'
   PUT #1, , Blue$
   PUT #1, , Green$
   PUT #1, , Red$
   PUT #1, , Empty$
NEXT Colors

SCREEN 13
'/* Saves the screen portion into BSAVE format */'
DIM Image%(1 TO 32767)
GET (MinX, MinY)-(MaxX, MaxY), Image%
ImageVarSeg = VARSEG(Image%(1))
ImageVarOffset = VARPTR(Image%(1))
DEF SEG = ImageVarSeg
BSAVE "temp.fil", ImageOffset, WidthInPixels * LengthInPixels

LineOfBytes$ = SPACE$(WidthInPixels): Padding$ = SPACE$(0)
IF (4 - (WidthInPixels MOD 4)) <> 4 THEN Padding$ = SPACE$((4 - (WidthInPixels MOD 4)))

Empty$ = SPACE$(11)
OPEN "temp.fil" FOR BINARY AS #2
'/* Extracts the unnecessary BSAVE format info */'
GET #2, , Empty$

FOR Loops = LengthInPixels - 1 TO 0 STEP -1
   '/* Extracts the bytes from the BSAVE file and places it into the BMP file */'
   GET #2, 12 + (WidthInPixels * Loops), LineOfBytes$
   PUT #1, , LineOfBytes$
   LINE (MinX, Loops)-(MaxX, Loops), 0
   '/* Puts extra padding into BMP if any is needed */'
   PUT #1, , Padding$
   NEXT Loops
CLOSE #2: KILL "temp.fil"

'/* Places the size of the file into the file */'
SizeOfFile$ = MKL$(LOC(1))
PUT #1, 3, SizeOfFile$

END SUB

